﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include <cmath>
using namespace std;
#define int long long
#define vector deque
vector<int> isp;
bool is(int n) {
	if (n == 1) {
		return 0;
	}
	for (int i = 2; i <= sqrt(n); i++) {
		if (n % i == 0) {
			return 0;
		}
	}
	return 1;
}

vector<vector<int>> gen(int n, int min) {
	if (min > n) {
		return {};
	}
	if (min == n && isp[min]==0) {
		return { {min} };
	}
	if (isp[min] == 1) {
		vector<vector<int>> l = gen(n, min + 1);
		return l;
	}
	vector<vector<int>> k = gen(n - min, min);
	for (int i = 0; i < k.size();i++) {
		k[i].push_front(min);
	}
	vector<vector<int>> l = gen(n, min + 1);
	for (auto i : k) {
		l.push_back(i);
	}
	return l;
}

signed main()
{
	isp.resize(100, 0);
	for (int i = 0; i < 100; i++) {
		if (is(i) == 1) {
			isp[i] = 1;
		}
	}
	int n;
	cin >> n;
	vector<vector<int>> h = gen(n, 1);
	for (int i = 0; i < h.size(); i++) {
		for (int j = 0; j < h[i].size(); j++) {
			cout << h[i][j];
			if (j != h[i].size() - 1) {
				cout << '+';
			}
		}
		cout << endl;
	}
}
