#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>

using namespace std;

using ll = long long;

long long n;
vector<long long> sum(n+1);

long long ib(long long x){
    long long l = 0, r = n;
    while(l != r && (l+1) != r){
        long long t = l + (r-l)/2;
        if(sum[t] >= x){
            r = t;
        }else{
            l = t;
        }
    }
    return r;
}

long long im(long long x){
    long long l = 0, r = n;
    while(l != r && (l+1) != r){
        long long t = l + (r-l)/2;
        if(sum[t] >= x){
            r = t;
        }else{
            l = t;
        }
    }
    return l;
}


int main(){
    ll L, R;
    ll ans1 = -1, ans2 = -1;
    cin >> L >> R;
    cin >> n;
    vector<ll> a(n);
    sum[0] = 0;
    for(ll k = 0; k < n; k++){
        cin >> a[k];
        sum[k+1] = sum[k] + a[k];
        //cout << sum[k+1] << " ";
    }
    ll u = 0;
    while(sum[u]<L){
        u++;
    }
    while(u <= n){
        ll x1 = ib(sum[u]-R);
        ll x2 = im(sum[u]-L);
        cout << x1 << " " << x2;
    if(x1 > x2){
        ans1 = sum[x1];
        ans2 = sum[u];
        break;
    }
    u++;
    }
    cout << ans1 << " " << ans2;
}
