﻿#include <iostream>
#include <numeric>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <algorithm>

using namespace std;
int ans = 0;

void geta(int n, int m, int mn, int mm) {
    if (n == 0 && m == 0) {
        ans++;
        return;
    }
    for (int i = mm; i <= m; i++) {
        for (int j = ((i == mm) ? mn : 0); j <= n; j++) {
            if (!(i == 0 && j == 0)) {
                geta(n - j, m - i, j, i);
            }
        }
    }
}

void solve() {
    int n;
    cin >> n;
    int h = -1, st = -1;
    for (int i = 24; i >= 1; i--) {
        int l1 = 6, r1 = 1e9 + 1;
        while (l1 < r1 - 1) {
            int mid = (l1 + r1) / 2;
            int x = n;
            bool b = true;
            for (int j = 0; j < i; j++) {
                if (x % mid != 0) {
                    b = false;
                }
                x /= mid;
                if (x == 0) {
                    break;
                }
            }
            if (x == 0 || (x == 1 && !b)) {
                r1 = mid;
            }
            else {
                l1 = mid;
            }
        }
        int x = 1;
        for (int j = 0; j < i; j++) {
            x *= l1;
        }
        if (x == n) {
            for (int j = 2; j * j < l1; j++) {
                if (n % j == 0) {
                    h = l1;
                    st = i;
                    break;
                }
            }
            if (l1 == h) {
                break;
            }
        }
    }
    geta(st, st, 0, 0);
    cout << ans - 1;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
}
