﻿#include <iostream>
#include <vector>
#include <string>
#include <deque>
#include <cmath>

using namespace std;

bool prime(int x) {
	if (x == 1) {
		return false;
	}
	for (int i = 2; i <= sqrt(x);i++) {
		if (x % i == 0) {
			return false;
		}
	}
	return true;
}

void rec(int n, vector<int> pref) {
	if (n == 0) {
		for (int i = 1; i < pref.size(); i++) {
			cout << pref[i];
			if (i != pref.size() - 1) {
				cout << "+";
			}
		}
		cout << "\n";
		return;
	}

	for (int i = pref.back(); i <= n / 2;i++) {
		if (prime(i)) {
			continue;
		}
		auto now = pref;
		now.push_back(i);
		rec(n - i, now);
	}

	if (prime(n)) {
	}
	else {
		auto now = pref;
		now.push_back(n);
		rec(n - n, now);
	}

}

signed main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n;
	cin >> n;

	rec(n, { 1 });

}

