#define _USE_MATH_DEFINES

#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

#define endl "\n";

template<typename T>
istream& operator>>(istream& in, vector<T>& arr_) {
    for (auto& i_ : arr_) {
        in >> i_;
    }
    return in;
}
template<typename T>
ostream& operator<<(ostream& out, vector<T>& arr_) {
    for (auto& i_ : arr_) {
        out << i_ << " ";
    }
    return out;
}


using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using str = string;

#define fast cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0)
#define p_b push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define int ll

bool check(int x) {
    for (int d = 2; d * d <= x; d++) {
        if (x % d == 0) {
            return false;
        }
    }
    return true;
}

vector<bool> is_pr;

vector<int> ans;

void solve(int pl) {
    if (pl == 0) {
        for (int i = 0; i < (int) ans.size(); i++) {
            cout << ans[i];
            if (i == (int) ans.size() - 1) {
                continue;
            }
            cout << '+';
        }
        cout << endl;
    }
    for (int x = ans.back(); x <= pl; x++) {
        if (!is_pr[x]) {
            ans.p_b(x);
            solve(pl - x);
            ans.pop_back();
        }
    }
}

signed main() {
    fast;

    int n;
    cin >> n;

    is_pr.resize(n);
    for (int x = 2; x < n; x++) {
        is_pr[x] = check(x);
    }

    for (int s = 1; s < n; s++) {
        if (!is_pr[s]) {
            ans = {s};
            solve(n - s);
        }
    }
}