#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <vector>

#define int long long

using namespace std;

int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	long long L, R, n;
	cin >> L >> R >> n;
	vector<long long> a(n), b(n);
	cin >> a[0];
	b[0] = a[0];
	for (int i = 1; i < n; ++i){
		cin >> a[i];
		b[i] = b[i - 1] + a[i];
	}
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; j++) {
			if (b[j] - b[i] <= R && b[j] - b[i] >= L) {
				cout << b[i] << ' ' << b[j];
				return 0;
			}
		}
	}
	cout << -1 << ' ' << -1;
}


/*
100
120
7
45
45
45
35
30
35
45
*/