#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

int n;
vector <int> ans;

bool not_simple(int a) {
    if (a == 1) return 1;
    for (int i = 2; i <= sqrt(a); i++) {
        if (a % i == 0) return 1;
    }
    return 0;
}

void rec(int s, int a) {
    if (s == n) {
        for (int i = 0; i < ans.size() - 1; i++) cout << ans[i] << "+";
        cout << ans.back() << '\n';
        return;
    }
    for (int i = a; s + i <= n; i++) {
        if (not_simple(i)) {
            ans.push_back(i);
            rec(s + i, i);
            ans.pop_back();
        }
    }
    return;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    rec(0, 0);
}
