#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

long long n, p, q, k = 0;

long long pqk(long long a) {
    for (int i = 2; i <= sqrt(a); i++) {
        while (a % i == 0) {
            k++;
            a /= i;
        }
        if (a < n) return i;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    p = pqk(n);
    q = pow(n / pow(p, k), 1.0 / k);
    if (k == 1) cout << 1;
    else if (k == 2) cout << 8;
    else if (k == 3) cout << 30;
    else cout << 0;
}
