
   

def is_prime(num):
    if num < 2:
        return False
    for i in range(2, int(num**0.5) + 1):
        if num % i == 0:
            return False
    return True

def non_simple_partitions(n, start=1, path=[]):
    partitions = []

   
    if n == 0:
        partitions.append('+'.join(map(str, path)))
        return partitions

    for i in range(start, n + 1):
        
        if is_prime(i):
            continue

        #
        partitions += non_simple_partitions(n - i, i, path + [i])

    return partitions


n = int(input())
result = non_simple_partitions(n)


for partition in result:
    print(partition)
