#include <iostream>
#include <vector>

using namespace std;

int n;
vector<int> not_prime;

void rec(int cur, int index, vector<int>& cur_ans) {
    if (cur == n) {
        for (int i = 0; i + 1 < cur_ans.size(); ++i)
            cout << cur_ans[i] << '+';
        cout << cur_ans.back() << '\n';
    }
    if (cur > n)
        return;

    for (int i = index; i < not_prime.size(); ++i) {
        cur_ans.push_back(not_prime[i]);
        rec(cur + not_prime[i], i, cur_ans);
        cur_ans.pop_back();
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    not_prime.push_back(1);
    for (int i = 4; i <= 70; ++i) {
        int count = 0;
        for (int j = 1; j <= i; ++j) {
            if (i % j == 0)
                ++count;
        }
        if (count > 2)
            not_prime.push_back(i);
    }

    cin >> n;
    vector<int> cur_ans;
    cur_ans.push_back(1);
    rec(1, 0, cur_ans);


    return 0;
}
