from itertools import accumulate


def bin_search(n):
    l, r = 0, len(trees_positions) - 1
    while l <= r:
        m = (l + r) // 2
        if trees_positions[m] == n:
            return m, True
        else:
            if trees_positions[m] > n:
                r -= 1
            else:
                l += 1
    return l, False



L, R = map(int, input().split())
amount = int(input())
arr = map(int, input().split())
trees_positions = list(accumulate(arr))

c = 0
for index, start in enumerate(trees_positions):
    edge_l, edge_r = start + L, start + R
    index_l, vl = bin_search(edge_l)
    index_r, vr = bin_search(edge_r)
    if vl:
        print(start, trees_positions[index_r])
        break
    elif not vl:
        print(trees_positions[index_l - 2], trees_positions[index_r + 1])
        break
    else:
        c += 1

if c == len(trees_positions):
    print(-1, -1)


'''
100 120
7
45 45 45 35 30 35 45
'''