def is_prime(num):
    if num < 2:
        return False
    for i in range(2, int(num ** 0.5) + 1):
        if num % i == 0:
            return False
    return True


def find_nonprime_partitions(n):
    def partitions_helper(num, start, partition):
        if num == 0 and len(partition) > 1 and not any(is_prime(x) for x in partition):
            return
        for i in range(start, num + 1):
            partitions_helper(num - i, i, partition + [i])

    partitions = []
    partitions_helper(n, 1, [])
    return partitions
    n = int(input())
nonprime_partitions = find_nonprime_partitions(n)

print(f"Непростые разбиения числа {n} на слагаемые:")
for partition in nonprime_partitions:
    print(partition)
    