﻿// Olimp.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>

unsigned long long L, R;

bool is_in_interval(unsigned long long value)
{
    if (value >= L && value <= R)
        return true;
    else
        return false;
}

int main()
{
    //============= Ввод ================
    unsigned int n;
    std::cin >> L >> R >> n;

    unsigned long long* dist = new unsigned long long[n+1];
    dist[0] = 0;

    for (int i = 1; i <= n; i++)
    {
        std::cin >> dist[i];
    }
    //=======================================

    unsigned long long interval = 0;
    int i, j;
    j = 0;

    for (i = 0; i < n; i++)
    {
        interval -= dist[i];
        if (interval < L)
        {
            for (j = j + 1; j <= n; j++)
            {
                interval += dist[j];
                if (is_in_interval(interval))
                {
                    while (i > 0)
                    {
                        interval += dist[i];
                        if (is_in_interval(interval))
                        {
                            i--;
                        }
                        else
                        {
                            break;
                        }
                    }
                    goto result;
                }
                if (R < interval)
                {
                    break;
                }
            }
        }
        else if (interval > R)
        {
            for (j = j - 1; j > i; j--)
            {
                interval -= dist[j + 1];
                if (is_in_interval(interval))
                {
                    while (i > 0)
                    {
                        interval += dist[i];
                        if (is_in_interval(interval))
                        {
                            i--;
                        }
                        else
                        {
                            break;
                        }
                    }
                    goto result;
                }
                if (R < interval)
                {
                    break;
                }
            }
        }
    }
    std::cout << -1 << ' ' << -1 << std::endl;
    return 0;

result:
    unsigned long long s, t;
    s = 0;
    t = 0;
    int k;
    for (k = 1; k <= i; k++)
    {
        s += dist[k];
    }
    t = s;
    for (k; k <= j; k++)
    {
        t += dist[k];
    }

    std::cout << s << ' ' << t << std::endl;

    return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
