def draw_intersection(n, l):
    intersection = []
    for i in range(n):
        row = []
        for j in range(n):
            if i >= (n - l) // 2 and i < (n + l) // 2:
                row.append("*")
            elif j >= (n - l) // 2 and j < (n + l) // 2:
                row.append("*")
            else:
                row.append(".")
        intersection.append(row)

    intersection = [" ".join(row) for row in intersection]
    return "\n".join(intersection)


n, l = int(input()), int(input())
print(draw_intersection(n, l))