def is_prime(num):
    if num < 2:
        return False
    for i in range(2, int(num**0.5) + 1):
        if num % i == 0:
            return False
    return True

def partition(n, current_partition, start):
    if n == 0:
        if len(current_partition) > 1 and all(not is_prime(num) for num in current_partition):
            print('+'.join(map(str, current_partition)))
    else:
        for i in range(start, n + 1):
            partition(n - i, current_partition + [i], i)

n = int(input())

partition(n, [], 1)