def count_triangles(a, b):
    k = 0
    for c in range(1, a + b + 1):
        if is_triangle(a, b, c) and is_positive_area(a, b, c):
            k += 1
    return k


def is_triangle(a, b, c):
    if a + b > c and a + c > b and b + c > a:
        return True
    return False


def is_positive_area(a, b, c):
    p = (a + b + c) / 2
    area = (p * (p - a) * (p - b) * (p - c)) ** 0.5
    if area > 0:
        return True
    return False


a = int(input())
b = int(input())

k = count_triangles(a, b)
print(k)
