def cut_ropes_length(n, k, d):
    left = 1
    right = n
    result = []

    while left <= right:
        mid = (left + right) // 2
        count = 0

        for rope in d:
            count += rope // mid

        if count >= k:
            left = mid + 1
        else:
            right = mid - 1

    for i in range(k):
        result.append(right)
        n -= right
        k -= 1

        if k > 0:
            right = min(n // k, right)

    return result


n = int(input())
k = int(input())
_ = int(input())
d = list(map(int, input().split()))

result = cut_ropes_length(n, k, d)
print(*result)