﻿#include <iostream>
#include <vector>
#include <cmath>

using namespace std;
#define ll long long

struct node {
	ll x, y, szx, szy;
};

ll binpow(ll n, ll p) {
	ll res = 1;
	while (p) {
		if (p & 1)
			res *= n;
		n *= n;
		p >>= 1;
	}
	return res;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll n, k, q;
	cin >> n >> k >> q;
	vector<node> helper(62);
	helper[0] = { n, n, 1, 0 };
	ll full = 0;
	ll dist = 0;

	for (ll i = 1; (1LL << i) <= n; i++) {
		ll x = helper[i - 1].x;
		ll y = helper[i - 1].y;
		ll szx = helper[i - 1].szx;
		ll szy = helper[i - 1].szy;
		if (x & 1) {
			helper[i].x = x / 2 + 1;
			helper[i].y = x / 2;
			helper[i].szx += szx;
			helper[i].szy += szx;
			if (y & 1 && szy) {
				helper[i].szx += szy;
				helper[i].szy += szy;
			}
			else {
				if (y / 2 == x / 2 + 1)
					helper[i].szx += szy * 2;
				else
					helper[i].szy += szy * 2;
			}
		}
		else {
			helper[i].x = x / 2;
			helper[i].szx = szx * 2;
			helper[i].szy = 0;
			if (y & 1 && szy) {
				helper[i].y = x / 2 - 1;
				helper[i].szx += szy;
				helper[i].szy += szy;
			}
			else {
				helper[i].szx += szy * 2;
			}
		}
	}

	ll kk = k;
	ll val = 0;
	while (kk >= (1LL << full)) {
		val += (1LL << full);
		kk -= (1LL << full);
		full++;
	}

	dist = k - val;
	//cout << "check: " << full << " " << dist << "\n";
	vector<pair<ll, ll>> v(4);
	ll x = helper[full].x;
	ll y = helper[full].y;
	ll szx = helper[full].szx;
	ll szy = helper[full].szy;
	ll id = 0;

	if (szx <= dist) {
		dist -= szx;
		v[id].first = y;
		v[id].second = szy - dist;
		id++;

		if (x & 1) {
			v[id].first = x / 2 + 1;
			v[id].second = szx;
			id++;

			v[id].first = x / 2;
			v[id].second = szx;
			id++;
		}
		if (y & 1) {
			id = 1;
			v[id].first = y / 2 + 1;
			v[id].second = dist;
			id++;

			v[id].first = y / 2;
			v[id].second = dist;
			id++;
		}
	}
	else {
		v[id].first = x;
		v[id].second = szx - dist;
		id++;
		if (szy) {
			v[id].first = y;
			v[id].second = szy;
			id++;
		}
		else {
			if (x & 1) {
				v[id].first = x / 2 + 1;
				v[id].second = dist;
				id++;

				v[id].first = x / 2;
				v[id].second = dist;
				id++;
			}
			else {
				v[id].first = x / 2 ;
				v[id].second = dist * 2;
			}
		}
	}

	for (ll i = 0; i < 4; i++) {
		//cout << "test: " << i << "  " << v[i].first << " " << v[i].second << "\n";
	}

	vector<ll> ans(q);

	for (ll i = 0; i < q; i++) {
		ll t;
		cin >> t;
		ll now = 0;

		for (ll j = 0; j < 4; j++) {
			now += v[j].second;
			if (now >= t) {
				//cout << v[j].first << " ";
				ans[i] = v[j].first;
				break;
			}
		}
	}

	for (ll i : ans)
		cout << i << " ";
}
