import java.util.*
import kotlin.collections.ArrayList

fun main(args: Array<String>) {

    val scanner = Scanner(System.`in`)

    val n = scanner.nextInt()
    val k = scanner.nextInt()
    val q = scanner.nextInt()
    val t = ArrayList<Int>().apply {
        for (i in 0 until q) {
            add(scanner.nextInt())
        }
    }

    val sets = ArrayList<ArrayList<Int>>()
    sets.add(ArrayList<Int>().apply { add(n) })

    repeat(k) {
        val tmp = sets[sets.size - 1]

        val res = ArrayList<Int>()
        val max = tmp.max()
        res.addAll(split(max))
        res.addAll(tmp)
        res.remove(max)

        sets.add(res)
    }

    val result = sets[sets.size - 1].apply { sort() }.reversed()

    t.forEach {
        print("${result[it - 1]} ")
    }

}

fun split(n: Int): ArrayList<Int> {
    return ArrayList<Int>().apply {
        if (n % 2 == 0) {
            add(n / 2)
            add(n / 2)
        } else {
            add((n * 10 / 2 - 5) / 10)
            add((n * 10 / 2 + 5) / 10)
        }
    }
}