#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <map>
#include <iomanip>

typedef long long ll;

std::map<ll, int> M;

int main( void )
{
  ll n, p = 0, q = 0;

  std::cin >> n;

  M = {
    {2, 1}, {3, 1}, {5, 1}, {7, 1}, {11, 1}, {13, 1}, {17, 1}, {19, 1}, {23, 1}, {29, 1}, {31, 1}, {37, 1}, {41, 1}, {47, 1}, {53, 1}, {59, 1}, {61, 1}, {67, 1}
  };

  for (auto& it : M)
    if (n % it.first == 0)
      if (p != 0)
        q = it.first;
      else
        p = it.first;

  for (ll i = 71; i < 1000000000000000000; i += 2)
  {
    int f = 1;
    for (auto& it : M)
      if (i % it.first == 0)
      {
        f = 0;
        break;
      }
    if (f)
      M[i] = 1;
    if (n % i == 0)
      if (p != 0)
        q = i;
      else
        p = i;
    if (p != 0 && q != 0)
      break;
  }

  int a = 0, b = 0;

  while (n != 1)
  {
    if (n % q == 0)
      n /= q, a++;
    if (n % p == 0)
      n /= p, b++;
  }

  double t = std::pow(2, (a * b - 1));

  //std::cout << t;

  std::string s = std::to_string(t);

  for (int i = 0; i < s.size(); i++)
    if (s[i] != '.')
      std::cout << s[i];
    else
      break;
  return 0;
}

/* 5
* std::map<ll, ll> M;

  ll n, k;
  int q;

  std::cin >> n >> k;

  M[n] = 1;

  while (k > 0)
  {
    ll a, b;
    a = (*(M.rbegin())).first / 2;
    b = (*(M.rbegin())).first - a;
    if ((*M.rbegin()).second != 1)
      (*M.rbegin()).second--;
    else
      M.erase((*M.rbegin()).first);
    M[a]++;
    M[b]++;
    k--;
  }

  std::cin >> q;

  for (int i = 0; i < q; i++)
  {
    ll t;
    std::cin >> t;
    auto it = M.end();
    it--;
    while (true)
    {
      if (t - (*it).second <= 0)
        break;
      t -= (*it).second;
      it--;
    }
    std::cout << (*it).first << " ";
  }
*/