﻿#include <vector>
#include <algorithm>
#include <iostream>

using namespace std;
void sum(vector<vector<int>> &a, int n, vector <bool> isprime, int &i) {
    if (n == 0) {
        i++;
        return;
    }
    for (int j = 1; j <= n; ++j) {
        if (!isprime[j]) {
            a[i].push_back(j);
            sum(a, n - j, isprime, i);
        }
    }
}

int main()
{
    //ввод
    int n, i = 0;
    cin >> n;
    vector<vector<int>> a(1e3, vector<int>(0));

    //вектор простых чисел
    vector<bool> isprime(n + 1, true);
    isprime[1] = false;
    for (int i = 2; i <= n; ++i) {
        for (int j = 2; j < i; ++j) {
            if (i % j == 0) {
                isprime[i] = false;
                break;
            }
        }
    }

    //поиск всех разложений
    sum(a, n, isprime, i);

    //вывод
    for (int i = 0; i < a.size(); ++i) {
        if (a[i].size() != 0) {
            sort(a[i].begin(), a[i].end());
            for (int j = 0; j < a[i].size() - 1; ++j) {
                    cout << a[i][j] << '+';
            }
            cout << a[i][a[i].size() - 1];
            cout << endl;
        }
    }
}
