#include <numeric>
#include <iostream>
#include <cmath>
#include <vector>

using namespace std;

int ns[] = {1, 4, 6, 8, 9, 10, 12, 14, 15, 16, 18, 20, 21, 22, 24, 25, 26, 27, 28, 30, 32, 33, 34, 35, 36, 38, 39, 40, 42, 44, 45, 46,
                    48, 49, 50, 51, 52, 54, 55, 56, 57, 58, 60, 62, 63, 64, 65, 66, 68, 69};
int nss = sizeof(ns) / sizeof(int);

void print_sums(int n, int l = 0, vector<int> prev = {}) {
    if (n < 0)
        return;
    if (n == 0) {
        for (int i = 0; i < prev.size(); i++)
            cout << prev[i] << (i == prev.size() - 1 ? "\n" : "+");
        return;
    }
    for (int i = l; i < nss; i++) {
        prev.push_back(ns[i]);
        print_sums(n - ns[i], i, prev);
        prev.pop_back();
    }
}

int main() {
    int n;

    cin >> n;

    print_sums(n);
    return 0;
}