﻿// ConsoleApplication1.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//
#include <string>
#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <cmath>
using namespace std;
#define ll long long

set<ll> primes;

ll n;

vector<bool> pr;

void all() {
	for (int i = 2; i <= sqrt(n); i++) {
		if (pr[i])
			continue;
		primes.insert(i);
		for (int j = i * i; j <= sqrt(n); j += i) {
			pr[i] = 1;
		}
	}
}

ll find() {
	ll k = 0;
	for (auto i : primes) {
		if (n % i == 0) {
			while (n % i == 0)
				n /= i, k++;
			break;
		}
	}
	return k;
}
void solve() {
	cin >> n;
	pr.resize(n);
	all();
	ll k = find();
	if (k == 1)
		cout << 1 << "\n";
	else
		cout << pow(2, 2 * k - 1);
}

int main()
{
	solve();
}
