#include <iostream>
#include <vector>
using namespace std;
bool is_prime(int num) {
    if (num < 2) {
        return false;
    }
    for (int i = 2; i * i <= num; i++) {
        if (num % i == 0) {
            return false;
        }
    }
    return true;
}
void partition(int n, int max_num, vector<int>& output) {
    if (n == 0) {
        for (int i = 0; i < output.size(); i++) {
            cout << output[i];
            if (i != output.size() - 1) {
                cout << " + ";
            }
        }
        cout << endl;
        return;
    }
    for (int i = 1; i <= min(max_num, n); i++) {
        if (!is_prime(i)) {
            output.push_back(i);
            partition(n - i, i, output);
            output.pop_back();
        }
    }
}
int main() {
    int n;
    cin >> n;
    vector<int> output;
    partition(n, n, output);
    return 0;
}
