import java.util.*;
import java.io.*;

public class Main {
	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		PrintWriter pw = new PrintWriter(System.out);
		
		HashSet<Integer> set = new HashSet<>();
		int n = sc.nextInt();
		for(int i = 2;i <= n;i++) {
			if(isPrime(i)) set.add(i);
		}
		rec(set,n,"",pw,n,1);
		
		pw.close();
	}
	public static boolean isPrime(int n) {
		for(int i = 2;i <= (int)Math.sqrt(n);i++) {
			if(n % i == 0) return false;
		}
		return true;
	}
	public static void rec(HashSet<Integer> set, int curr,String str,PrintWriter pw,int n,int min) {
		if(curr <= 0) pw.println(str.substring(1));
		str += "+";
		for(int i = min;i < n;i++) {
			if(curr-i < 0) break;
			if(set.contains(i)) continue;
			rec(set,curr-i,str + String.valueOf(i),pw,n,i);
		}
	}
}