import java.util.*;
import java.io.*;
 
public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        PrintWriter pw = new PrintWriter(System.out);
         
        long n = sc.nextLong();
        int k = sc.nextInt();
        int q = sc.nextInt();
        
        int[] queries = new int[q];
        
        for(int i =0;i< q;i++) {
        	queries[i] = sc.nextInt();
        }
        
        PriorityQueue<Long> pq = new PriorityQueue<>(Collections.reverseOrder());
        
        pq.add(n);
        
        for(int i = 0;i < k;i++) {
        	long cur = pq.poll();
        	
        	if(cur % 2 == 1) {
        		pq.add((cur+1)/2);
            	pq.add(cur/2);
        	}
        	else {
        		pq.add(cur/2);
            	pq.add(cur/2);
        	}
        	
        }
        
        ArrayList<Long> list = new ArrayList<>();
        
        
        while(!pq.isEmpty()) {
        	list.add(pq.poll());
        }
        
        for(int j = 0;j < q;j++) {
        	pw.println(list.get(queries[j]-1));
        }
        
        pw.close();
    }
     
    
}