def is_prime(num):
    if num < 2:
        return False
    for i in range(2, int(num ** 0.5) + 1):
        if num % i == 0:
            return False
        else:
            return True

def non_prime_partitions(n, curr, result):
    if n == 0:
        result.append(curr.copy())
        return
    if n < 0:
        return
    start = 1 if not curr else curr[-1]
    for i in range(start, n + 1):
        if not is_prime(i):
            curr.append(i)
    non_prime_partitions(n - i, curr, result)
    curr.pop()

def get_non_prime_partitions(n):
    result = []
    non_prime_partitions(n, [], result)
    return result
n=int(input())
partitions = get_non_prime_partitions(n)
for partition in partitions:
    print(" + ".join(map(str, partition)))