def complicated_partition(n): 
    if n <= 1: 
        return [[n]] 
    else: 
        result = [] 
        for k in range(2, n // 2 + 1): 
            for partition in complicated_partition(n - k): 
                if not (k + any(x == k for x in partition)) and k not in partition: 
                    result.append([k] + partition) 
        return result 

  
n = 5 
for partition in sorted(complicated_partition(n)): 
    print(f"{partition[0]}+{partition[1]}+{partition[2]}+{partition[3]}+{partition[4]}") 
