def make_next_list(lst, el_max):
    for i in range(len(lst) - 1, -1, -1):
        if lst[i] < el_max:
            lst[i] += 1
            for j in range(i + 1, len(lst)):
                lst[j] = 1
            return True
    return False


def count_razl(k):
    res = set()
    for i in range(1, k + 1):
        lst = [1] * i
        while True:
            if sum(lst) == k:
                res.add(tuple(sorted(lst)))
            if not make_next_list(lst, k):
                break
    return len(res)


n = int(input())

K = -1
for k in range(1, 20):
    if abs(round(n ** (1 / k)) - n ** (1 / k)) <= 0.0001:
        K = k


print(count_razl(K) ** 3)
