def is_prime(num):
    """
    Функция для проверки, является ли число простым.
    """
    if num < 2:
        return False
    for i in range(2, int(num**0.5) + 1):
        if num % i == 0:
            return False
    return True
def non_prime_partitions(n, start=2):
    """
    Функция для генерации непростых разбиений числа n.
    """
    results = []
    if n == 0:
        return [[]]
    for i in range(start, n + 1):
        if not is_prime(i):
            sub_partitions = non_prime_partitions(n - i, i)
            for partition in sub_partitions:
                results.append([i] + partition)

    return results
n = int(input())
partitions = non_prime_partitions(n)
for partition in partitions:
    print("+".join(map(str, partition)))