#include <iostream>
#include <vector>
#include <algorithm>

typedef unsigned long long ul;

std::vector<ul> operation(std::vector<ul> &ropes) {
    ul max_rope = *std::max_element(ropes.begin(), ropes.end());
    ropes.erase(std::remove(ropes.begin(), ropes.end(), max_rope), ropes.end());
    ropes.push_back(max_rope / 2);
    ropes.push_back(max_rope - max_rope / 2);
    return ropes;
}


int main() {
    ul length, k, q;
    std::cin >> length >> k;
    std::vector<ul> ropes = {length};
    for (ul i = 0; i < k; ++i) {
        ropes = operation(ropes);
    }
    std::sort(ropes.rbegin(), ropes.rend());
    std::cin >> q;
    std::vector<ul> indexes(q);
    for (ul i = 0; i < q; ++i) {
        std::cin >> indexes[i];
        indexes[i]--;
    }
    for (ul index : indexes) {
        std::cout << ropes[index] << " ";
    }
    return 0;
}