def is_prime(num):
    if num < 2:
        return False
    for i in range(2, int(num ** 0.5) + 1):
        if num % i == 0:
            return False
    return True

def generate_partitions(n, start, path):
    if n == 0:
        print('+'.join(map(str, path)))
        return
    for i in range(start, n+1):
        if not is_prime(i):
            generate_partitions(n-i, i, path + [i])

n = int(input())
path = []
generate_partitions(n, 1, path)
