from itertools import accumulate, combinations


def wayfinder(l, r, n, ds):
    treesleng = list(accumulate(ds))
    treesleng.append(0)
    treescomb = list(combinations(treesleng, 2))
    rescombs = []
    for comb in treescomb:
        if comb[1] <= comb[0]:
            continue
        elif (comb[1] - comb[0] < l) or (comb[1] - comb[0] > r):
            continue
        else:
            rescombs.append(comb)
    resrs = [i[0] for i in rescombs]
    resls = [i[1] for i in rescombs]
    return str(min(resrs)), str(min(resls))


lnr = list(map(int, input().split()))
l = lnr[0]
r = lnr[1]
n = int(input())
ds = list(map(int, input().split()))

if len(ds) != n:
    print("-1 -1")

try:
    print(" ".join(wayfinder(l, r, n, ds)))
except:
    print("-1 -1")