#include <iostream>
#include <cmath>
#include <vector>
#include <set>

using namespace std;

set<vector<int>> razlo;

bool isPrime (int a) {
    if (a == 0 || a == 1 || a == 2) {
        return true;
    }
    for (int i = 2; i < sqrt(a) + 1; i++) {
        if(a % i == 0) {
            return false;
        }
    }
    return true;
}

bool noOrd(vector<int> arr) {
    int pr = arr[0];
    for(int i = 0; i < arr.size(); i++) {
        if(arr[i] < pr) {
            return true;
        }
        pr = arr[i];
    }
    return false;
}

void vecOut(vector<int> arr) {
    if(noOrd(arr)) {
        return;
    }
    for(size_t i = 0; i < arr.size(); i++) {
        if(i != arr.size() - 1) {
            cout << arr[i] << "+";
        } else {
            cout << arr[i];
        }
    }
    cout << endl;
}

int check(vector<int> arr, int from) {
    int sum = 0;
    for(int i = from; i >= 0; i--) {
        sum += arr[i];
        if(!isPrime(sum) && i != from) {
            return i;
        }
    }
    return -1;
}

vector<int> sokr(vector<int> arr, int from, int to) {
    vector<int> res;
    for(int i = 0; i < from; i++) {
        res.push_back(arr[i]);
    }
    int sum = 0;
    for(int i = from; i <= to; i++) {
        sum += arr[i];
    }
    res.push_back(sum);
    for(int i = to + 1; i < arr.size(); i++) {
        res.push_back(arr[i]);
    }
    return res;
}

void rec(vector<int> arr, int to) {
    if(to == 0) {
        return;
    }
    rec(arr, to - 1);
    int ck = check(arr, to);
    if(ck != -1) {
        arr = sokr(arr, ck, to);
        rec(arr, arr.size() - 1);
        if(razlo.count(arr) == 0) {
            vecOut(arr);
            razlo.insert(arr);
        }
    }

}


int main() {
    int n;
    cin >> n;
    vector<int> razl(n, 1);
    vecOut(razl);

    int new_size = n;

    rec(razl, razl.size() - 1);
}
