#include <iostream>
#include <vector>

bool has(int a) {
    if (a == 1) return false;
    for (int g = 2; g * g <= a; ++g) {
        if (a % g == 0) {
            return false;
        }
    }
    return true;
}

void solve(int n, int x, std::vector<int>& cals) {
    if (n < 0) return;
    if (n != 0) {
        for (int i = x; i <= n; i++) {
            if (!has(i)) {
                std::vector<int> nc(cals);
                nc.push_back(i);
                solve(n - i, x, nc);
            }
        }
    }
    else {
        std::cout << cals[0];
        for (int i = 1; i < cals.size(); i++) {
            std::cout << "+" << cals[i];
        }
        std::cout << std::endl;
        return;
    }
}

void main(void) {
	int n;
	std::cin >> n;
    for (int i = 1; i <= n; i++) {
        if (!has(i)) {
            std::vector<int> ls = { i };
            solve(n - i, i, ls);
        }
    }
    return;
}