import math

def is_prime(num):
    if num < 2:
        return False
    for i in range(2, int(math.sqrt(num)) + 1):
        if num % i == 0:
            return False
    return True
def generate_partitions(n, partition, result):
    if n == 0:
        result.append(partition)
        return
    for i in range(1, n + 1):
        if not is_prime(i) and i <= partition[-1]:
            generate_partitions(n - i, partition + [i], result)
n = int(input())

partitions = []
generate_partitions(n, [n], partitions)

print(n)
for partition in partitions:
    print(partition)
