#define _GLIBCXX_DEBUG
#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
template<typename T>
istream& operator>>(istream&in, vector<T>&a){
    for (auto &i:a)in>>i;
    return in;
}
template<typename T>
ostream& operator<<(ostream&in, vector<T>&a){
    for (auto &i:a)in<<i<<'\n';
    return in;
}
template<typename T>
ostream& operator<<(ostream&out, vector<vector<T>>&a){
    for (auto &i:a)out<<i<<'\n';
    return out;
}
struct Test{
    int m;
    vector<bool>prime;
    Test(){
        cin>>m;
        prime.resize(m+2,true);
        prime[0]=prime[1]=false;
        ans.reserve(m+1);
    }
    vector<int>ans;
    void print(){
        int k=ans.size();
        for (int i=0;i<k-1;i++)cout<<ans[i]<<'+';
        cout<<ans[k-1]<<'\n';
    }
    void gen(int n, int pref){
        if (n==0){
            print();
            return;
        }
        for (int i=pref;i<=n;i++){
            if (!prime[i]){
                ans.push_back(i);
                gen(n-i,i);
                ans.pop_back();
            }
        }
    }
    void work(){
        for (int i=2;i<m+1;i++){
            if (prime[i]){
                for (int j=i*i;j<m+1;j+=i)prime[j]=false;
            }
        }
        gen(m,1);
    }
};
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    Test a;
    a.work();
}
