#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

int main() {
    long long n;
    int k, q;
    cin >> n >> k >> q;
    multiset<long long> st;
    st.insert(n);
    for (int i = 0; i < k; i++) {
        auto it = st.end();
        it--;
        st.erase(it);
        long long x = *it;
        st.insert(x / 2);
        st.insert(x / 2 + x % 2);
    }
    vector<long long> a;
    for (auto x : st) {
        a.push_back(x);
    }
    sort(a.rbegin(), a.rend());
    for (int i = 0; i < q; i++) {
        int x;
        cin >> x;
        cout << a[x - 1] << " ";
    }
    cout << "\n";
    return 0;
}
