#include<bits/stdc++.h>
using namespace std;
long long n;
long long deg(long long a, int b) {
	long long ans = (long long)1;
	for (int i = 1; i <= b; i++) {
		if (a > n / ans) {
			return n + (long long)1;
		}
		ans *= a;
	}
	return ans;
}
bool prime(int a) {
	if (a == 1) {
		return false;
	}
	if (a == 2) {
		return true;
	}
	for (int i = 3; i <= sqrt(a); i++) {
		if (a % i == 0) {
			return false;
		}
	}
	return true;
}
bool check(long long _) {
	int x = (int)_;
	for (int i = 2; i < sqrt(x); i++) {
		if (x % i) {
			continue;
		}
		return i != n / i && prime(i) && prime(x / i);
	}
	return true;
}
bool find(int k) {
	long long l = (long long)1, r = n + (long long)1, m;
	while (r - l > (long long)1) {
		m = (l + r) >> 1;
		if (deg(m, k) > n) {
			r = m;
		} else {
			l = m;
		}
	}
	return deg(l, k) == n && check(l);
}
int ANS = 0;
int K;
void count(int ka, int kb, int a, int b) {
	if (ka == K && kb == K) {
		++ANS;
		return;
	}
	for (int i = 0; i <= K - ka; i++) {
		for (int j = 0; j <= K - kb; j++) {
			if ((i || j) && deg((__int128)2, i) * deg((__int128)3, j) >= deg((__int128)2, a) * deg((__int128)3, b)) {
				count(ka + i, kb + j, i, j);
			}
		}
	}
}
void main_solve(void) {
	cin >> n;
	int k = 2;
	for (; k < 64; k++) {
		if (find(k)) {
			break;
		}
	}
	if (k == 64) {
		cout << 1 << endl;
		return;
	}
//  cout << k << endl;
	K = k;
	count(0, 0, 0, 0);
	cout << ANS - 1 << endl;
}
int main() {
	int _TeSt_CoUnT_ = 1;
//  cin >> _TeSt_CoUnT_;
	while (_TeSt_CoUnT_--) {
		main_solve();
	}
	return 0;
}
