﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

#pragma GCC optimize("03")
#pragma GCC optimize("unroll_loops")
#pragma GCC optimie("avx,avx2,bmi2,fma")

#define endl '\n'

signed main()
{
#ifdef lisie_bimbi
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    cin >> n;
    vector<bool> pr(n + 1, true);
    pr[1] = false;
    for (int i = 2; i <= n; i++) {
        for (int j = 2; j < i; j++) {
            if (i % j == 0) {
                pr[i] = false;
            }
        }
    }
    vector<vector<string>> dp1(n + 1);
    vector<vector<string>> dp2(n + 1);
    dp1[0] = { "" };
    for (int mx = 1; mx <= n; mx++) {
        dp2.clear();
        dp2.resize(n + 1);
        dp2[0] = { "" };
        for (int i = 1; i <= n; i++) {
            dp2[i] = dp1[i];
            if (mx <= i && !pr[mx]) {
                for (auto str : dp2[i - mx]) {
                    dp2[i].push_back(str + "+" + to_string(mx));
                }
            }
        }
        swap(dp1, dp2);
    }
    for (auto i : dp1[n]) {
        i = i.substr(1, i.size());
        cout << i << endl;
    }
    return 0;
}