﻿#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <algorithm>
using namespace std;
#define ll size_t

ll pw(ll a, ll n) {
    ll res = 1;
    for (int i = 0; i < n; i++) {
        res = a * res;
        if (res < 0)
            return -1;
    }
    return res;
}

ll ans = 0;

void solve(ll a, ll b, ll mn_a, ll mn_b) {
    if (a == 0 && b == 0)
        ans++;
    for (int i = mn_a; i <= a; i++) {
        if (i == mn_a) {
            for (int j = mn_b; j <= b; j++) {
                if (i + j != 0)
                    solve(a - i, b - j, i, j);
            }
        }
        else {
            for (int j = 0; j <= b; j++)
                solve(a - i, b - j, i, j);
        }
    }
}

int main()
{
    ll n;
    cin >> n;
    ll sqr = -1;
    vector<double> rs = {1e+18, 1e+09, 1e+06, 31622.8, 3981.07, 1000, 372.759, 177.828, 100, 63.0957, 43.2876, 31.6228, 24.2446, 19.307, 15.8489, 13.3352, 11.4505, 10 };
    for (int i = 1; i <= 18; i++) {
        ll l = 1, r = 1e2;
        if (i - 1 < rs.size())
            r = rs[i - 1];
        while (r - l > 1) {
            ll m = (l + r) / 2;
            ll pw_res = pw(m, i);
            if (pw_res <= n && pw_res != -1)
                l = m;
            else
                r = m;
        }
        if (pw(l, i) == n)
            sqr = i;
    }
    if (sqr == -1 || sqr > 18)
        return -1;
    vector<ll> res = { 1, 8, 30, 108, 338, 1042, 2997, 8405, 22651, 59520, 151957, 379692, 927621, 2224234, 5236585, 12130779, 27669592, 62229989 };
    cout << res[sqr - 1] << "\n";
}
