#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

bool sostav(int n){
    int s = 1;
    if(n == 1) return true;
    for(int i = 1; i <= sqrt(n); ++i){
        if(n % i == 0){
            ++s;
        }
        if(s > 2){
            return true;
        }
    }
    return false;
}

void f(int n, int maxx, vector<int> &vv, vector<vector<int>> &vV){
    if(n == 0){
        vV.push_back(vv);
        return;
    }
    for(int i = 1; i <= n; ++i){
        if(i <= maxx && sostav(i)){
            vv.push_back(i);
            f(n - i, i, vv, vV);
            vv.pop_back();
        }
    }
}

int main(){
    int n;
    cin >> n;
    vector<int> v;
    vector<vector<int>> V;
    f(n, n, v, V);

    for(int i = 0; i < V.size(); ++i){
        sort(V[i].begin(), V[i].end());
        for(int j = 0; j < V[i].size(); ++j){
            cout << V[i][j];
            if(j != V[i].size() - 1){
                cout << " + ";
            }
        }
        cout << '\n';
    }
}
