﻿#include <iostream>
#include <vector>

using namespace std;
using ll = long long;

pair <ll, ll> bp(vector <ll>& ps, ll &l, ll &r, ll b, int idx)
{
	ll lp = -1;
	ll rp = ps.size();
	ll m;
	while (rp - lp > 1)
	{
		m = (lp + rp) / 2;
		if (ps[m] - b >= l) rp = m;
		else lp = m;
	}
	if (rp != ps.size())
	{
		if (ps[rp] - b < l || ps[rp] - b > r) return bp(ps, l, r, ps[idx + 1], idx + 1);
		return { b, ps[rp] };
	}
	else
	{
		if (ps[lp] - b < l || ps[lp] - b > r) return bp(ps, l, r, ps[idx + 1], idx + 1);
		return { b, ps[lp] };
	}
}

int main()
{
	ll l, r;
	cin >> l >> r;
	int n;
	cin >> n;
	vector <ll> ps(n + 1);
	for (int i = 1; i < n + 1; i++)
	{
		int tmp;
		cin >> tmp;
		ps[i] = ps[i - 1] + tmp;
	}
	pair <ll, ll> ans = bp(ps, l, r, 0, 0);
	cout << ans.first << ' ' << ans.second;
	return 0;
}