﻿#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;
using ll = long long;

int gmidx(vector <ll> &v)
{
	ll maxx = INT64_MIN;
	int maxidx;
	for (int i = 0; i < v.size(); i++)
	{
		if (v[i] > maxx)
		{
			maxx = v[i];
			maxidx = i;
		}
	}
	return maxidx;
}

bool comp(ll e1, ll e2)
{
	if (e1 > e2) return true;
	else return false;
}

int main()
{
	ll n, k;
	cin >> n >> k;
	int q;
	cin >> q;
	vector <int> reqs(q);
	for (int i = 0; i < q; i++) cin >> reqs[i];
	vector <ll> now = { n };
	for (int a = 0; a < k; a++)
	{
		int idx = gmidx(now);
		now.push_back(now[idx] / 2);
		now.push_back(now[idx] - now[idx] / 2);
		now.erase(now.begin() + idx);
	}
	sort(now.begin(), now.end(), comp);
	for (int req : reqs) cout << now[req - 1] << ' ';
	return 0;
}