﻿// ConsoleApplication1.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#include <set>
using namespace std;
typedef long long ll;

int main()
{
    ll L, R;
    cin >> L >> R;
    ll n;
    cin >> n;
    vector<ll> d(n, 0);
    for (ll& el : d) {
        cin >> el;
    }

    vector <ll> prefsum(n + 1, 0);
    for (int i = 1; i < prefsum.size(); i++) {
        prefsum[i] = prefsum[i - 1] + d[i - 1];
    }

    for (int j = 1; j < prefsum.size(); j++) {
        int l = 0; int r = j;
        int m = (l + r) / 2;
        while (r - l > 1) {
            if (prefsum[j] - prefsum[m] > L) {
                l = m;
            }
            else if (prefsum[j] - prefsum[m] <= L) {
                r = m;
            }
            m = (l + r) / 2;
        }
        
        if (prefsum[j] - prefsum[l] >= L && prefsum[j] - prefsum[l] <= R) {
            cout << prefsum[l] << ' ' << prefsum[j] << '\n';
            return 0;
        }
    }

    cout << "-1 -1\n";
    return 0;
}
