﻿#include <iostream>
#include <vector>
#include <string>
#include <deque>
#include <cmath>
#include <set>
#include <map>

using namespace std;

long long ans = 0;

void rec(long long n, vector<long long> pref) {
	if (n == 1) {
		if (pref.size() == 2) {
			return;
		}
		ans++;
		return;
	}
	for (long long i = max(pref.back(), 2ll); i <= n; i++) {
		if (n % i == 0) {
			auto now = pref;
			now.push_back(i);
			rec(n / i, now);
		}
	}
}

signed main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	long long n;
	cin >> n;


	long long s = 0;

	for (long long k = 1; k <= 24; k++) {
		long long r = pow(double(n), double(1) / double(k));
		if (pow(r, k) == n || pow(r-1, k) == n || pow(r+1, k) == n) {
			s = k;
		}
	}

	long long k = s;

	rec(pow(6ll, k), { 1 });

	cout << ans << endl;

}

