﻿#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <iomanip>
#include <vector>
#include <cstdint>
#include <set>

#define int long long
#define vec vector
#define all(a) a.begin(), a.end()

using namespace std;

void solve() {
    int L, R; cin >> L >> R;
    int n; cin >> n;
    vec<int> a(n); for (auto& e : a) cin >> e;
    set<int> pref;
    pref.insert(0);
    int last = 0;
    for (int i = 0; i < n; i++) {
        pref.insert(last + a[i]);
        last += a[i];
        auto it = pref.lower_bound(last - R);
        if (it != pref.end()) {
            if ((*it) <= last - L) {
                cout << (*it) << ' ' << last << '\n';
                return;
            }
        }
    }
    cout << "-1 -1";
}

int32_t main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
