#include <iostream>
#include <string>

const int primes[19]{2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67};

std::string toString(int x)
{
    std::string s;
    if(x < 10)
        s += (char)(x + '0');
    else
    {
        s += (char)(x / 10 + '0');
        s += (char)(x % 10 + '0');
    }
    return s;
}

void print(int N, int n, int min = 1, int i = 0, std::string str = "")
{
    if(n >= min)
    {
        while(min <= n)
        {
            if(min == 2)
            {
                min++;
                i++;
            }
            if(min == primes[i])
            {
                if(++i == 19) i--;
                min++;
            }
            print(N, n - min, min, i, str + (str == "" ? "" : "+") + toString(min));
            min++;
        }
    }
    else if(n == 0)
    {
        std::cout << str + "\n";
    }
}

int main()
{
    int n;
    std::cin >> n;

    print(n, n);

    return 0;
}