#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

int main() {
	ll L, R;
	int	n;
	cin >> L >> R >> n;
	vector<ll> d(n + 1);
	for (int i = 1; i <= n; ++i) {
		int x;
		cin >> x;
		//d[i] = x;
		d[i] = d[i - 1] + x;
	}
	//for (int i = 0; i <= n; ++i)
	//	cout << "#" << d[i];
	//cout << endl;
	for (int r = 1; r <= n; ++r) {
		if (d[r] < L || d[r] - d[r - 1] > R) continue;
		int lo = 0, hi = r;
		while (hi - lo > 1) {
			int m = (hi + lo) / 2;
			if (d[m] <= d[r] - L)
				lo = m;
			else
				hi = m;
		}
		//cout << "#" << lo << endl;
		int x1 = lo;
		lo = 0, hi = r - 1;
		while (hi - lo > 0) {
			int m = (hi + lo) / 2;
			//cout << hi << " " << lo << " " << m << endl;
			if (d[m] >= d[r] - R)
				hi = m;
			else
				lo = m + 1;
		}
		int x2 = lo;
		//cout << "#" << x2 << endl;
		//cout << r << endl << endl;
		if (d[x2] >= d[r] - R && x1 >= x2) {
			cout << d[x2] << " " << d[r] << "\n";
			return 0;
		}
	}
	cout << "-1 -1\n";
}