#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
    int left, right, amount_of_trees;
    cin >> left >> right >> amount_of_trees;

    vector<long long> pref;
    pref.push_back(0);

    for(int i = 0; i < amount_of_trees; ++i) {
        long long x;
        cin >> x;
        pref.push_back(pref[pref.size() - 1] + x);
    }

    int i = 0;
    while(true) {
        long long need = pref[i] + right;

        long long l = -1, r = pref.size();
        while(r - l > 1) {
            long long m = (r + l) / 2;
            if(pref[m] > need)
                r = m;
            else
                l = m;
        }
        if(pref[l] - pref[i] >= left && pref[l] - pref[i] <= right) {
            cout << pref[i] << " " << pref[l];
            exit(0);
        }
        ++i;
    }
    return 0;
}
