﻿#include <iostream>
#include <vector>
#include <string.h>
#include <algorithm>
#include <math.h>
#include <map>
#include <set>

using namespace std;

#define int long long

const int inf = 1e18 + 1;

bool ppprime(int h) {
	int cnt = 0;
	for (int i = 2; i < sqrt(h); i++) {
		if (h % i == 0) {
			cnt++;
		}
	}
	if (cnt == 1) {
		return true;
	}
	else {
		return false;
	}
}

int pow(int a, int b) {
	if (b == 0) {
		return 1;
	}
	int res = pow(a, b - 1);
	if (inf / a < res) {
		return inf;
	}
	else {
		return min(inf, res * a);
	}
}

signed main() {
	int n;
	cin >> n;
	int ans = -1;
	int step = -1;
	for (int k = 23; k >= 2; k--) {
		int l = 0;
		int r = n;
		while (r - l > 1) {
			int mid = (l + r) / 2;
			if (pow(mid, k) > n) {
				r = mid;
			}
			else {
				l = mid;
			}
		}
		int tek = l;
		if (pow(l, k) != n) {
			continue;
		}
		if (!ppprime(l)) {
			continue;
		}
		ans = l;
		step = k;
		break;
	}
	if (ans == -1) {
		cout << "1\n";
		return 0;
	}
	else {
		if (step == 1) {
			cout << "1\n";
			return 0;
		}
		int p, q;
		int k;
		k = step;
		for (int i = 2; i < ans; i++) {
			if (ans % i == 0) {
				p = i;
				q = ans / p;
				break;
			}
		}
		vector<int> d;
		map<int, int> e;
		int del = (k + 1) * (k + 1);
		for (int i = 0; i <= k; i++) {
			for (int j = 0; j <= k; j++) {
				d.push_back(pow(p, i) * pow(q, j));
			}
		}
		sort(d.begin(), d.end());
		for (int i = 0; i < del; i++) {
			e[d[i]] = i;
		}
		vector<vector<int>> dp(del, vector<int>(del));
		for (int i = 1; i < del; i++) {
			dp[i][i] = 1;
		}
		for (int i = 1; i < del; i++) {
			int f = d[i];
			for (int j = 1; j < i; j++) {
				if (f % d[j] == 0) {
					dp[i][j] += dp[e[f / d[j]]][j];
				}
			}
			for (int j = 1; j < del; j++) {
				dp[i][j] += dp[i][j - 1];
			}
		}
		cout << dp[del - 1][del - 1] - 1 << "\n";
	}
}