﻿#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

vector <int> pref;

int f(int i, int j)
{
	return pref[j + 1] - pref[i];
}

/*
100 120
7
45 45 45 35 30 35 45
*/

signed main()
{
	int ll, rr;
	cin >> ll >> rr;
	int n;
	cin >> n;
	vector <int> mas(n + 1);
	mas[0] = 0;
	for (int i = 0; i < n; i++)
	{
		cin >> mas[i + 1];
	}
	n++;

	pref.resize(n + 1);
	pref[0] = 0;
	for (int i = 0; i < n; i++)
	{
		pref[i + 1] = pref[i] + mas[i];
	}

	vector <pair <int, int>> ans;
	for (int i = 0; i < n; i++)
	{
		int l = i - 1, r = n;
		while (r - l > 1)
		{
			int m = (l + r) / 2;
			if (f(i + 1, m) >= ll && f(i + 1, m) <= rr)
			{
				r = m;
			}
			else
			{
				l = m;
			}
		}
		if (r != n)
		{
			ans.push_back({ r, i });
		}
	}
	sort(ans.begin(), ans.end());
	if (ans.size() == 0)
	{
		cout << -1 << " " << -1;
	}
	else
	{
		cout << f(0, ans[0].second - 1) << " " << f(0, ans[0].first - 1);
	}
}