﻿
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#define int long long

using namespace std;

signed main() {
    int a, b;
    cin >> a >> b;
    int n;
    cin >> n;
    vector <int> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    vector <int> p(n);
    p[0] = v[0];
    for (int i = 1; i < n; ++i) {
        p[i] = p[i - 1] + v[i];
    }
    int l = 0, r = 0;
    vector  <pair <int, int>> t;
    bool flag = false;
    while (l < n && r < n) {
        if (p[r] - p[l] < a) {
            r++;
        }
        else if (p[r] - p[l] > b) {
            l++;
        }
        else {
            t.push_back({ p[r], p[l] });
            flag = true;
            l++;
        }
    }
    sort(t.begin(), t.end());
    if (t[0].first == t[1].first) {
        vector <pair <int, int>> ans;
        int now = 1;
        ans.push_back({ t[0].second, t[0].first });
        while (t[now].first == t[0].first) {
            ans.push_back({ t[now].second, t[now].first });
            now++;
        }
        sort(ans.begin(), ans.end());
        cout << ans[0].first << " " << ans[0].second;
    }
    else {
        cout << t[0].second << " " << t[0].first;
    }
    if (!flag) {
        cout << -1 << " " << -1;
    }
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
