def cut_ropes(n, k):
    ropes = [n]
    for _ in range(k):
        longest_rope = max(ropes)
        ropes.remove(longest_rope)

        if longest_rope % 2 == 0:
            ropes.extend([longest_rope // 2] * 2)
        else:
            ropes.extend([longest_rope // 2, longest_rope // 2 + 1])

    return sorted(ropes, reverse=True)

n = int(input())
k = int(input())
q = int(input())
queries = list(map(int, input().split()))

result = cut_ropes(n, k)

output = ""
for query in queries:
    output += f"{result[query - 1]} "
print(output)
