L, R = map(int, input().split())
n = int(input())
trees = list(map(int, input().split()))
trees_prefix = [0, trees[0]]
for i in range(1, n):
    trees_prefix.append(trees[i] + trees_prefix[i])

variants = []
for start in range(n+1):
    if trees_prefix[-1] - trees_prefix[start] < L:
        break
    else:
        for end in range(start+1, n+1):
            if L <= trees_prefix[end] - trees_prefix[start] <= R:
                variants.append([start, end])
            elif trees_prefix[end] - trees_prefix[start] > R:
                break

if len(variants) == 0:
    print(-1, -1)
else:
    variants.sort()
    print(trees_prefix[variants[0][0]], trees_prefix[variants[0][1]])
