def print_intersection(n, l):
    # Проверка на четность размера перекрестка
    if n % 2 == 0:
        center = n // 2
    else:
        center = n // 2 + 1
    
    # Изначально все клетки вне дороги
    grid = [['.' for _ in range(n)] for _ in range(n)]
    
    # Рисование вертикальной дороги
    for i in range(center - l // 2, center + l // 2):
        for j in range(n):
            grid[i][j] = '*'
    
    # Рисование горизонтальной дороги
    for i in range(n):
        for j in range(center - l // 2, center + l // 2):
            grid[i][j] = '*'
    
    # Вывод перекрестка
    for row in grid:
        print(' '.join(row))

# Пример использования функции
n = 7 # Размер перекрестка
l = 3  # Ширина дороги
print_intersection(n, l)










