#include <iostream>
#include <cstdint>

#define u32 uint_fast32_t

using namespace std;

int main () {
    u32 size, width, offstart, offend;
    std::cin >> size >> width;

    auto vertical = new char [size+1];
    auto horizontal = new char [size+1];

    for (int i = 0; i < size; i++) {
        vertical[i] = 46;       // .
        horizontal[i] = 42;     // *
    }
    offstart = (size-width)>>1;
    offend = offstart + width;

    for (int i = offstart; i < offend; i++) {
        vertical [i] = 42;      // *
    }

    for (int i = 0; i < size; i++)
     {
         std::cout << ((i >= offstart && i < offend) ? horizontal : vertical) << std::endl;

     }

    delete vertical;
    delete horizontal;

}
