import math

def is_short_triangle(a, b, c, side_threshold=10, area_threshold=5):
  
    if a <= side_threshold and b <= side_threshold and c <= side_threshold:
        
        s = (a + b + c) / 2
        area = math.sqrt(s * (s - a) * (s - b) * (s - c))
        return area <= area_threshold
    return False

def count_short_triangles(a, b):
    
    if a > b:
        a, b = b, a

    count = 0

    
    for c in range(a + 1, a + b):
        if c > b and is_short_triangle(a, b, c):
            count += 1

    return count


a = int(input("(a):"))
b = int(input("(b):"))


result = count_short_triangles(a, b)
print(f"(c):{result}")








