def is_prime(num):
    if num < 2:
        return False
    for i in range(2, int(num**0.5) + 1):
        if num % i == 0:
            return False
    return True

def partition(n, curr_sum, curr_num, path):
    if curr_sum == n and path:
        print('+'.join(map(str, path)))
        return
    if curr_sum > n or curr_num > n:
        return
    if is_prime(curr_num):
        partition(n, curr_sum, curr_num + 1, path)
    else:
        partition(n, curr_sum + curr_num, curr_num, path + [curr_num])
        partition(n, curr_sum, curr_num + 1, path)

n = int(input("Введите число n: "))
partition(n, 0, 2, [])

