﻿// vs001.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>

#pragma GCC optimize("03,unroll-loop")

typedef long long ll;

using namespace std;

#define min(a, b) (a < b ? a : b)
#define max(a, b) (a > b ? a : b)

vector<int> simples = { 2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67 };
const int simple_size = 19;

vector<vector<ll>> solves;

bool is_simple(int num) {
    for (int i = 0; i < simple_size; i++) {
        if (num == simples[i]) return true;
        if (simples[i] > num) return false;
    }
    return false;
}

ll sum(vector<ll> vec) {
    ll sum = 0;
    for (int i = 0; i < vec.size(); i++) {
        sum += vec[i];
    }
    return sum;
}

bool vec_equal(vector<ll> vec1, vector<ll> vec2) {
    if (vec1.size() != vec2.size()) return false;
    for (int i = 0; i < vec1.size(); i++) {
        if (vec1[i] != vec2[i]) return false;
    }
    return true;
}

bool vec_in_solves(vector<ll> vec) {
    for (int i = 0; i < solves.size(); i++) {
        if (vec_equal(vec, solves[i])) return true;
    }
    return false;
}

void add(vector<ll> vec) {

    std::sort(vec.begin(), vec.end());


    if(!vec_in_solves(vec)) solves.push_back(vec);
}

void check(vector<ll> vec, ll num) {
    ll vec_sum = sum(vec);
    if (vec_sum == num) add(vec);
    for (ll i = 1; i <= num - vec_sum; i++) {
        if (!is_simple(i)) {
            vector<ll> new_vec = vec;
            new_vec.push_back(i);
            check(new_vec, num);
            new_vec.resize(1);
        }
    }
}

int main()
{
    ll n;
    cin >> n;

    vector<ll> vec = { n };
    vector<ll> numvec(1);
    for (ll i = 1; i < n / 2; i++) {
        numvec[0] = i;
        if(!is_simple(i)) check(numvec, n);
    }

    for (int j = 0; j < solves.size(); j++) {
        for (int i = 0; i < solves[j].size() - 1; i++) {
            cout << solves[j][i] << "+";
        }
        cout << solves[j][solves[j].size() - 1] << "\n";
    }

    return 0;
}