def get_ans(dp, primes, n):
    if n in dp:
        return dp[n]
    if n == 0:
        return []
    a = []
    for i in range(1, n+1):
        if i not in primes:
            tmp = get_ans(dp, primes, n-i)
            for j in tmp:
                a.append([i] + j)
    dp[n] = a
    return a

def print_expr(e):
    expr = sorted(e)
    s = str(expr[0])
    for i in range(1, len(expr)):
        s = s + "+" + str(expr[i])
    print(s)

n = int(input())

dp = {1: [[1]]}
primes = {}
r = [i for i in range(n+1)]
r[1] = 0
for i in range(2, int((n+1)//2)+1):
    if r[i]:
        for j in range(2 * r[i], n+1, r[i]):
            r[j] = 0
for i in r:
    if i:
        primes[i] = 1
ans = get_ans(dp, primes, n)
for i in ans:
    print_expr(i)
