def find_distance(L, R, n, distances):
    distances.sort()
    start = 0
    end = 0
    min_diff = float('inf')
    min_start = -1
    min_end = -1

    while end < n:
        while distances[end] - distances[start] > R:
            start += 1
        if distances[end] - distances[start] >= L and distances[end] - distances[start] < min_diff:
            min_start = distances[start]
            min_end = distances[end]
            min_diff = distances[end] - distances[start]
        end += 1

    if min_start == -1:
        return -1, -1
    else:
        return min_start, min_end

L, R = map(int, input().split())
n = int(input())
distances = list(map(int, input().split()))
start, end = find_distance(L, R, n, distances)
print(start, end)