#include <iostream>
#include <vector>
using namespace std;

vector<int> count_dist_from_start(vector<int> arr) {
    vector<int> result;
    for (int i = 0; i < arr.size(); i++) {
        int sum = 0;
        for (int j = 0; j <= i; j++) {
            sum += arr[j];
        }
        result.push_back(sum);
    }
    return result;
}

int main() {
    int L, R;
    cin >> L >> R;
    int n;
    cin >> n;
    vector<int> D(n);
    for (int i = 0; i < n; i++) {
        cin >> D[i];
    }
    vector<int> arr = {0};
    vector<int> dist_from_start = count_dist_from_start(D);
    arr.insert(arr.end(), dist_from_start.begin(), dist_from_start.end());
    bool found = false;
    for (int i = 0; i < arr.size(); i++) {
        for (int j = i; j < arr.size(); j++) {
            if (abs(arr[i] - arr[j]) > R) {
                break;
            }
            if (L <= abs(arr[i] - arr[j]) && abs(arr[i] - arr[j]) <= R) {
                cout << arr[i] << " " << arr[j] << endl;
                found = true;
                break;
            }
        }
        if (found) {
            break;
        }
    }
    if (!found) {
        cout << -1 << " " << -1 << endl;
    }
    return 0;
}

