def is_prime(num):
    if num < 2:
        return False
    for i in range(2, int(num**0.5) + 1):
        if num % i == 0:
            return True
    return False

def non_prime_partitions(n, current_partition=[]):
    if n == 0:
        print('+'.join(map(str, current_partition)))
        return
    for i in range(1, n + 1):
        if not is_prime(i) and (not current_partition or i >= current_partition[-1]):
            non_prime_partitions(n - i, current_partition + [i])

# Чтение входных данных
n = int(input())

# Вызов функции для поиска непростых разбиений
non_prime_partitions(n)