#include <bits/stdc++.h>
using namespace std;

vector<long long> mults;

int get_k(long long n) {
    int k = 0;
    for (long long i = 2; i * i <= n; ++i) {
        int k_p = k;
        while (n % i == 0) {
            n /= i;
            ++k;
        }
        if (k != k_p) mults.push_back(i);
        if (mults.size() == 2) return k/2;
    }
    if (n > 1) mults.push_back(n);
    return k/2;
}

unordered_map<long, int> matrix[5000];
unordered_map<long, bool> visited[5000];

int get_res(int inx, long long left) {
    if (left == 1) {
        return 1;
    }
    if (inx < 0) return 0;
    if (visited[inx][left]) return matrix[inx][left];
    visited[inx][left] = true;


    for (long long mult = 1; left % mult == 0; mult *= mults[inx]) {
        matrix[inx][left] += get_res(inx - 1, left / mult);
    }
    return matrix[inx][left];
}


int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    long long n;
    cin >> n;

    int k = get_k(n);
    long long fir = 1, sec = 1;
    for (int a = 0; a <= k; ++a) {
        for (int b = 0; b <= k; ++b, sec *= mults[1]) {
            if (a < 2 && b < 1 || a < 1 && b < 2 || a == k && b == k) continue;
            mults.push_back(fir*sec);
        }
        fir *= mults[0];
        sec = 1;
    }
    cout << get_res(mults.size()-1, n)  << '\n';
    return 0;
}
