def is_prime(num):
    if num < 2:
        return False
    for i in range(2, int(num**0.5) + 1):
        if num % i == 0:
            return False
    return True

def nonprime_partitions(n, start=1, partition=[]):
    if n == 0:
        if partition:
            print('+'.join(map(str, partition)))
    else:
        for i in range(start, n + 1):
            if not is_prime(i):
                partition.append(i)
                nonprime_partitions(n - i, i, partition)
                partition.pop()

n = int(input())
nonprime_partitions(n)

