import java.util.*;

public class D {

    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        byte n = in.nextByte();
        in.close();

        List<List<Byte>> divisions = divisions(n);
        List<List<Byte>> res = new ArrayList<>(divisions);

        for (List<Byte> l : divisions) {
            l.sort(Comparator.comparing(b -> (Byte)b));
        }

        for (List<Byte> l : divisions) {
            if (l.stream().anyMatch(b -> isPrimeNumber(b))) {
                res.remove(l);
            }
        }

        for (int i = 0; i < divisions.size(); i++) {
            for (int j = 0; j < divisions.size(); j++) {
                if (i != j) {
                    if (contains(divisions.get(i), divisions.get(j))) {
                        res.remove(divisions.get(j));
                    }
                }
            }

        }

        System.out.println(res);

    }

    public static List<List<Byte>> divisions(int num) {
        List<List<Byte>> list = new LinkedList<>();
        for (byte i = 1; i <= num; i++) {
            List<Byte> basicList = new ArrayList<>(num);
            byte plus = i;
            for (byte j = 1; j <= num; j++) {
                basicList.add(plus);
                if (num - plus * (j + 1) < 0) {
                    plus = 1;
                }
                if (sum(basicList) > num) {
                    basicList.remove(basicList.size() - 1);
                    break;
                }
            }
            list.add(basicList);
            while (true) {
                basicList = new ArrayList<>(basicList);
                if (basicList.size()  >= 2) {
                    byte i1 = basicList.get(basicList.size() - 1);
                    basicList.remove(basicList.size() - 1);
                    byte i2 = basicList.get(basicList.size() - 1);
                    basicList.set(basicList.size() - 1, (byte)(i1+ i2));
                    list.add(basicList);
                } else {
                    break;
                }
            }
        }
        return list;
    }

    public static byte sum(List<Byte> list) {
        byte res = 0;
        for (Byte i: list) {
            res += i;
        }
        return res;
    }

    private static boolean isPrimeNumber(byte n) {
        if (n == 1) {
            return false;
        }
        for (byte i = 2; i < n; i++) {
            if (n % i == 0) {
                return false;
            }
        }
        return true;
    }

    private static boolean contains(List l1, List l2) {
        if (l1.size() != l2.size()) {
            return false;
        }
        for (int i = 0; i < l1.size(); i++) {
            if (l1.get(i) != l2.get(i)) {
                return false;
            }
        }
        return true;
    }

}
