﻿#include <iostream>
#include <vector>
#include <cmath>

using namespace std;
#define ll long long

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	ll L, R;
	ll n;
	cin >> L >> R >> n;
	vector<ll> a(n + 1);
	vector<ll> pref(n + 1);
	for (ll i = 1; i <= n; i++) {
		cin >> a[i];
		pref[i] = a[i] + pref[i - 1];
	}

	if (L == R) {
		cout << 0 << " " << 0;
		return 0;
	}

	ll now = 0;

	ll x = -1, y = -1;
	ll l = 0, r = 0;

	for (ll i = 1; i <= n; i++) {
		now += a[i];
		//cout << "test: " << now << " " << l << " " << i << "\n";
		if (L <= now && now <= R) {
			x = pref[l - 1];
			y = pref[i];
			break;
		}
		while (now > R) {
			now -= a[l];
			l++;
		}
	}

	cout << x << " " << y;
}
