﻿#include <iostream>
#include <vector>
#include <cmath>

using namespace std;
#define ll long long

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	ll L, R;
	int n;
	cin >> L >> R >> n;
	vector<ll> a(n + 1);
	vector<ll> pref(n + 1);
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
		pref[i] = a[i] + pref[i - 1];
	}

	if (L == R) {
		cout << 0 << " " << 0;
		return 0;
	}

	ll now = 0;
	ll l = 0;

	for (int i = 0; i < n; i++) {
		if (L <= pref[i] - pref[l] && pref[i] - pref[l] <= R) {
			cout << pref[l] << " " << pref[i];
			return 0;
		}
		while (pref[i] - pref[l] > R)
			l++;
	}

	cout << -1 << ' ' << -1;
}
