
def is_prime(num):
    if num < 2:
        return False
    for i in range(2, int(num**0.5) + 1):
        if num % i == 0:
            return False
    return True

def make_conclusion(n):
    def helper(first_conclusion, primary_sum, start):
        if primary_sum == 0:
            nonlocal result
            result.append(list(first_conclusion))
            return
        for i in range(start, primary_sum+1):
            if not is_prime(i):
                first_conclusion.append(i)
                helper(first_conclusion, primary_sum-i, i)
                first_conclusion.pop()

    result=[]
    helper=([], n, 1)
    return result


n=int(input())
conclusions=make_conclusion(n)
for conclusion in conclusions:
    print(conclusion)



