// C

#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <fstream>

using namespace std;

int main() {
  ifstream in("in C.txt");

  int64_t L, R;
  int N;
  
  cin >> L >> R;                       
  cin >> N;
  
  vector<int> D(N);
  for (int i = 0; i < N; i++) {
    cin >> D[i];
  }

  vector<int> psum(N + 1, 0);
  psum[0] = 0;
  for (int i = 1; i < N + 1; i++) {
    psum[i] = psum[i - 1] + D[i - 1];
  }


  int Xmin = -1, Xmax = -1, mn = -1, mx = -1;
  vector<int> Vmin(N), Vmax(N);

  for (int i = 0; i < N; i++) {
    Xmin = -1, Xmax = -1, mn = -1;
    for (int k = 0; k <= N - i; k++) {
      Xmin = i;
      if (psum[i + k] >= L + psum[i] && mn == -1) {
        mn = i + k;
      }

      if (mn != -1 && psum[i + k] <= R + psum[i]) {
        Vmin[i] = Xmin;
        Vmax[i] = mn;
        break;
      }
      else if (mn != -1 && psum[i + k] > R + psum[i]) {
        Vmin[i] = -1;
        Vmax[i] = -1;
        break;
      }
    }
  }

  //for (int i = 0; i < N; i++) {
   // cout << Vmin[i] << ' ' << Vmax[i] << '\n';
  //}


  for (int i = 0; i < N; i++) {
    {//if (psum[Vmin[i]] + L <= psum[Vmax[i]]) {
      if (Vmin[i] != -1 && Vmax[i] != -1)
        cout << psum[Vmin[i]] << ' ' << psum[Vmax[i]] << '\n';
    }
    break;
  }
  
  return 0;
}