#include <iostream>
#include <vector>
#include <math.h>

int IsPrime(int a)
{
	int k = sqrt(a);

	if (a == 1)
		return 1;
	for (int i = 2; i < k + 1; i++)
	{
		if (a % i == 0)
			return 1;
	}
	return 0;
}

int n = 0;
std::vector<int> A;

void Print(int p)
{
	if (p == 0)
		return;
	for (int i = 0; i < p - 1; i++)
	{
		std::cout << A[i] << "+";
	}
	std::cout << A[p - 1] << "\n";
}
void recurse(void)
{
	Print(n);
	for (int i = n - 1; i > 1; i--)
	{
		A[i - 1] += A[i];
		if (IsPrime(A[i - 1]))
		{
			Print(i);
		}
	}
}
int main(void)
{
	std::cin >> n;
	A.resize(n);
	for (int i = 0; i < n; i++)
	{
		A[i] = 1;
	}
	recurse();
}