#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
 
typedef unsigned long long ull;
 
int main( void )
{
  ull l, r;
  int n;
  std::cin >> l >> r;
  std::cin >> n;
  std::vector<int> d;
  d.resize(n);
 
  for (int i = 0; i < n; i++)
    std::cin >> d[i];
 
  int i1 = -1, i2 = -1;
 
  for (int i = 0; i < d.size(); i++)
  {
    ull sum = 0;
    int m;
    for (m = i; sum < l && m < d.size(); m++)
    {
      sum += d[m];
    }
 
    if (sum < l)
      break;
    else if (sum <= r && sum >= l)
    {
      i1 = i;
      i2 = m;
      break;
    }
  }
 
  if (i1 == -1 || i2 == -1)
    std::cout << i1 << " " << i2;
  else
  {
    ull sum1 = 0, sum2 = 0;
 
    for (int i = 0; i < i2; i++)
    {
      sum2 += d[i];
      if (i < i1)
        sum1 += d[i];
    }
 
    std::cout << sum1 << " " << sum2;
  }
 
  return 0;
}