#include <vector>
#include <algorithm>
#include <iostream>

typedef long long llong;
typedef unsigned long long ullong;

using namespace std;

int main( void )
{
  ullong N, K;
  int Q;
  cin >> N, cin >> K, cin >> Q;

  std::vector<ullong> Qstns(Q);
  for (int i = 0; i < Q; i++)
    cin >> Qstns[i];

  std::vector<ullong> Vec = {N};

  for (int i = 0; i < K; i++)
  {
    std::vector<ullong>::const_iterator vecit = std::max_element(Vec.begin(), Vec.end());
    ullong part = *vecit._Ptr;
    *vecit._Ptr = part / 2;
    Vec.push_back(part - part / 2);
  }

  std::sort(Vec.begin(), Vec.end(), [](ullong a, ullong b) { return a > b; });

  for (int i = 0; i < Q; i++)
  {
    cout << Vec[Qstns[i] - 1];
    if (i != Q - 1)
      cout << " ";
  }

  return 0;
}
