#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <iterator>
#include <bitset>
#include <cstdlib>
#include <unordered_map>
#include <unordered_set>
#include <chrono>
#include <random>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    long long l, r;
    cin >> l >> r;
    long long n;
    cin >> n;
    vector<long long> a(n);
    for (auto &i : a) {
        cin >> i;
    }
    vector<long long> pref(n + 1, 0);
    for (long long i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + a[i - 1];
    }
    for (long long i = -1; i < n; i++) {
        auto it = lower_bound(pref.begin(), pref.end(), pref[i + 1] + l);
        long long pos = it - pref.begin();
        if (pos <= n && pref[pos] - pref[i + 1] >= l && pref[pos] - pref[i + 1] <= r) {
            cout << pref[i + 1] << " " << pref[pos];
            return 0;
        }
    }
    cout << "-1 -1";
    return 0;
}