def is_prime2(x):
    if x == 1:
        return False
    if x == 2:
        return False # !!!
    d = 3
    x2 = ceil(sqrt(x))
    while d <= x2:
        if x % d == 0:
            return False
        d += 2
    return True


def is_pq(x):
    if x % 2 == 0:
        if is_prime2(x // 2):
            return 2, x // 2
        return None, None
    d = 3
    x2 = ceil(sqrt(x))

    while d <= x2:
        if x % d == 0:
            if is_prime2(x // d):
                return d, x // d
            return None, None
        else:
            d += 2
    return None, None
    

def go(p_cnt, q_cnt, last, level):
    global RES
    if p_cnt == 0 and q_cnt == 0:
        if level == 1:
            return
        RES += 1
        return
    level += 1
    for i in range(p_cnt + 1):
        for j in range(q_cnt + 1):
            if i == 0 and j == 0:
                continue
            d = (p ** i) * (q ** j)
            if d < last:
                continue
            go(p_cnt - i, q_cnt - j, d, level)

def find(n, k):
    if k == 1:
        return n
    l = 1
    r = n
    while True:
        if l + 1 == r:
            a = l ** k
            b = r ** k
            if a < n and b > n:
                return None

        m = (l + r) // 2
        v = m ** k
        if v == n:
            return m
        if v > n:
            r = m
        else:
            l = m

        if l == r:
            return None

def find2(s, n, k):
    s = ceil(s)
    while s ** k >= n:
        if s ** k == n:
            return s
        s -= 1
    return None

from math import *

RES = 0

n = int(input())
max_k = int(log(n, 6))
for k in range(1, max_k + 1):
    s = n ** (1.0/k)
    x = find2(s, n, k)
    if x is None:
        continue
    p, q = is_pq(x)
    if p is None:
        continue
#    print(p, q, k)
    go(k, k, 0, 0)
    print(RES)
    quit()
f = 1 / 0



