def is_prime(num):
    if num < 2:
        return False
    for i in range(2, int(num**0.5) + 1):
        if num % i == 0:
            return False
    return True

def non_prime_partitions(n):
    def helper(start, target, current):
        if target == 0:
            print(current)
        elif target > 0:
            for num in range(start, target + 1):
                if not is_prime(num):
                    helper(num, target - num, current + [num])

    helper(2, n, [])

n = int(input("Введите число n: "))
print("Непростые разбиения числа", n, "на слагаемые:")
non_prime_partitions(n)