#include <iostream>
#include <set>
#include <vector>

using namespace std;

int main()
{
    long long n, k;
    int q;
    cin >> n >> k >> q;
    multiset<long long> ropes = {n};
    for (long long i = 0; i < k; ++i) {
        long long temp = *(ropes.crbegin());
        ropes.erase(--ropes.end(), ropes.end());
        if (temp % 2 == 0) {
            ropes.insert(temp / 2);
            ropes.insert(temp / 2);
        } else {
            ropes.insert(temp / 2 + 1);
            ropes.insert(temp / 2);
        }
    }
    vector<long long> rope;
    for (auto el: ropes) {
        rope.push_back(el);
    }
    for (int i = 0; i < q; ++i) {
        long long t;
        cin >> t;
        cout << rope[rope.size() - t] << " ";
    }
}
