def draw_intersection(n, l):
    intersection = [['.' for _ in range(n)] for _ in range(n)]

    start = (n - l) // 2  # Начальная позиция дороги

    # Рисуем горизонтальную дорогу
    for i in range(start, start + l):
        intersection[n // 2][i] = "*"

    # Рисуем вертикальную дорогу
    for i in range(start, start + l):
        intersection[i][n // 2] = "*"

    return intersection

def print_intersection(intersection):
    for row in intersection:
        print(''.join(row))

n = int(input())
l = int(input())

intersection = draw_intersection(n, l)
print_intersection(intersection)
