#define _CRT_SECURE_NO_WARNINGS

#include <cstdio>

struct Distance {
	int beginAt, endAt;
	bool isMinEA = false, isMinBA = false;
};

int main() {
	long long int L, R;
	int n, countDistances = 0, minEA = sizeof(int), minBA = sizeof(int), indexRes;

	std::scanf("%lld%lld%d", &L, &R, &n);

	const int size = n;

	int* d = new int[n + 1];
	d[0] = 0;
	for (int i = 1; i <= n; i++) {
		std::scanf("%d", &d[i]);
		d[i] + d[i - 1];
	}

	for (int i = 0; i < n; i++)
		for (int j = i; j < n; j++)
			if (d[i] + d[j] >= L && d[i] + d[j] <= R)
				countDistances++;

	if (countDistances == 0) {
		std::printf("-1 -1");
		return 1;
	}

	Distance* res = new Distance[countDistances];

	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			if (d[i] + d[j] >= L && d[i] + d[j] <= R) {
				res[j].endAt = d[j];
				res[j].beginAt = d[i];
			}

	for (int i = 0; i < countDistances; i++) {
		if (res[i].beginAt < minBA)
			minBA = res[i].beginAt;
		if (res[i].endAt < minEA)
			minEA = res[i].endAt;
	}

	int countMinEA = 0;
	for (int i = 0; i < countDistances; i++) {
		if (res[i].beginAt == minBA)
			res[i].isMinBA = true;
		if (res[i].endAt == minEA) {
			res[i].isMinEA = true;
			countMinEA++;
		}
	}

	if (countMinEA == 1) {
		for (int i = 0; i < countDistances; i++)
			if (res[i].isMinEA)
				printf("%d %d", res[i].beginAt, res[i].endAt);
	} else {
		for (int i = 0; i < countDistances; i++)
			if (res[i].isMinEA && res[i].isMinBA) {
				printf("%d %d", res[i].beginAt, res[i].endAt);
			}
	}
	
	delete[] d;
	delete[] res;
	return 0;
}