def cut_ropes(k, rope_length):
    # Создаем список для хранения длин веревочек
    ropes = [rope_length]

    # Повторяем операцию k раз
    for _ in range(k):
        # Находим самую длинную веревочку
        longest_rope = max(ropes)

        # Удаляем эту веревочку из списка
        ropes.remove(longest_rope)

        # Разрезаем веревочку на две примерно равные части
        if longest_rope % 2 == 0:
            rope1 = rope2 = longest_rope // 2
        else:
            rope1 = longest_rope // 2
            rope2 = longest_rope // 2 + 1

        # Добавляем новые веревочки в список
        ropes.append(rope1)
        ropes.append(rope2)

    # Возвращаем список длин веревочек
    return ropes


# Пример использования функции
rope_length = int(input(""))
k = int(input(""))
q = int(input(""))
q_arr = list(map(int, input("").split()))

results = cut_ropes(k, rope_length)
results.sort(reverse=True)

for ask in q_arr:
    print(results[ask - 1])

