def find_distances(l, r, n, d):
    # Проверяем, что дистанция начинается либо в начале дороги, либо около какого-то дерева
    if l not in d and l != 0:
        return print("-1 -1")

    # Проверяем, что дистанция заканчивается у дерева
    if r not in d:
        return print("-1 -1")

    # Находим возможные дистанции
    possible_distances = []
    for i in range(n):
        for j in range(i + 1, n + 1):
            distance = sum(d[i:j])
            if distance >= l and distance <= r:
                possible_distances.append((distance - d[i], distance))

    # Выводим результат
    if len(possible_distances) == 0:
        return print("-1 -1")
    else:
        return possible_distances


# Ввод данных с клавиатуры
l, r = map(int, input().split())
n = int(input())
d = list(map(int, input().split()))

# Вызов функции и вывод результата
result = find_distances(l, r, n, d)
print(result)
