n = int(input())

def is_prime(num):
    if num < 2:
        return False
        
    for i in range(2, int(num**0.5) + 1):
        if num % i == 0:
            return False
        return True

def decompose(n, k, cur_list):
    if n == 0:
        print(' + '.join(map(str, cur_list)))
        return
    
    if k == 0 or n < 0:
        return
    
    decompose(n, k-1, cur_list)
    if not is_prime(k):
        decompose(n - k, k, cur_list + [k])
        
decompose(n, n, [])