#include <iostream>
#include <vector>

void main(void) {
	int lim = std::pow(16, 5);
	long long L, R, n;
	std::cin >> L >> R >> n;
	std::vector<long long> sum(n+1);
	std::vector<long long> arr(n+1);
	arr[0] = 0;
	sum[0] = 0;
	for (int i = 1; i < n+1; i++) {
		std::cin >> arr[i];
		sum[i] = sum[i - 1] + arr[i];
	}
	
	int aj = lim, ai = lim;
	if (n == 1) {
		if (sum[1] >= L && sum[1] <= R) std::cout << 0 << " " << sum[1] << std::endl;
		else std::cout << -1 << " " << -1 << std::endl;
		return 0;
	}
	for (int i = n - 1; i >= 0; i--) {
		for (int j = i - 1; j >= 0; j--) {
			long long d = sum[i] - sum[j];
			if (d >= L && d <= R) {
				if (j < aj) {
					aj = j;
					ai = i;
				}
			}
			//else if (d < L) break;
		}
	}
	if (aj != lim && ai != lim) std::cout << sum[aj] << " " << sum[ai] << std::endl;
	else std::cout << -1 << " " << -1 << std::endl;
}