#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <cmath>
#include <random>
#include <string>
#include <climits>

using namespace std;
using ll = long long;

pair<ll, ll> del = make_pair(-1, -1);
ll step = 0;
set<vector<ll>> res;
vector<ll> step1, step2;

void func(ll x, vector<ll> ls) {
    if (x == 1) {
        sort(ls.begin(), ls.end());
        res.insert(ls);
        return;
    }
    for (ll n = 0; n <= step; n++) {
        if (x % step1[n] != 0) {
            break;
        }
        for (ll m = 0; m <= step; m++) {
            if (x % step2[m] != 0) {
                break;
            }
            if ((n != 0 || m != 0) && (n != step || m != step)) {
                ll p = step1[n] * step2[m];
                ls.push_back(p);
                func(x / p, ls);
                ls.pop_back();
            }
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n;
    cin >> n;
    ll t = n;
    ll i = 2;
    while (i * i <= n) {
        if (n % i == 0) {
            if (del.first == -1) {
                del.first = i;
            } else {
                del.second = i;
            }
            while (n % i == 0) {
                n /= i;
                if (i == del.first) {
                    step++;
                }
            }
        }
        i++;
    }
    if (n != 1) {
        del.second = n;
    }
    step1.resize(step + 1);
    step1[0] = 1;
    step2.resize(step + 1);
    step2[0] = 1;
    for (ll i = 1; i <= step; i++) {
        step1[i] = step1[i - 1] * del.first;
        step2[i] = step2[i - 1] * del.second;
    }
    vector<ll> p(0);
    func(t, p);
    cout << res.size();
}