#include<bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
ll l, r;
void solve() {
    ll n;
    cin >> l >> r >> n;
    vector<ll>d(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    vector<ll>dist(n + 1);
    dist[0] = 0;
    for (int i = 0; i < n; ++i) {
        dist[i + 1] = dist[i] + d[i];
    }
    ll finish = 0;
    ll ansR = -1, ansL = -1;
    for (ll st = 0; st < n; ++st) {
        while (finish < n && (dist[finish] - dist[st] < l)) {
            finish++;
        }
        if (finish < n && (dist[finish] - dist[st] <= r)) {
            if (ansR == -1 || finish < ansR) {
                ansR = finish;
                ansL = st;
            } else if (finish == ansR && ansL > st) {
                ansR = finish;
                ansL = st;
            }
        }
    }
    if (ansR == -1) {
            cout << ansL << ' ' << ansR;
    } else {
        cout << dist[ansL] << ' ' << dist[ansR];
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
