#include <iostream>
#include <vector>

void print(std::vector<long long> a) {
    for (auto i : a) {
        std::cout << i << ' ';
    }
    std::cout << std::endl;
}

int WinMain() {
    long long L, R;
    std::cin >> L >> R;

    long long n;
    std::cin >> n;

    std::vector<long long> d(n + 1);
    for (int i = 1; i <= n; i++) {
        std::cin >> d[i];
    }

    long long sum = 0;
    std::vector<long long> s(n + 1);
    for (int i = 1; i <= n; i++) {
        sum += d[i];
        s[i] = sum;
    }

    // print(d);
    // print(s);

    long long l = 0, r = 0;
    bool run = true;
    bool next = true;
    bool complete = false;
    while (run) {
        while ((s[r] - s[l]) < L) {
            r++;
            if (s[r] - s[l] >= L and s[r] - s[l] <= R) {
                // std::cout << l << ' ' << r << std::endl;
                run = false;
                next = false;
                complete = true;
                break;
            }
        }
        while ((s[r] - s[l]) > R and next) {
            l++;
            if (s[r] - s[l] >= L and s[r] - s[l] <= R) {
                // std::cout << l << ' ' << r << std::endl;
                run = false;
                next = false;
                complete = true;
                break;
            }
        }
    }

    if (complete) {
        std::cout << s[l] << ' ' << s[r] << std::endl;
    } else std::cout << "-1 -1" << std::endl;

    return 0;
}